/* This file is is generated by a shell script.  DO NOT EDIT! */

/* 32 bit ELF emulation code for pruelf
   Copyright (C) 1991-2022 Free Software Foundation, Inc.
   Written by Steve Chamberlain <sac@cygnus.com>
   ELF support by Ian Lance Taylor <ian@cygnus.com>

   This file is part of the GNU Binutils.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston,
   MA 02110-1301, USA.  */

#define TARGET_IS_pruelf

#include "sysdep.h"
#include "bfd.h"
#include "libiberty.h"
#include "getopt.h"
#include "bfdlink.h"
#include "ctf-api.h"
#include "ld.h"
#include "ldmain.h"
#include "ldmisc.h"
#include "ldexp.h"
#include "ldlang.h"
#include "ldfile.h"
#include "ldemul.h"
#include <ldgram.h>
#include "elf-bfd.h"
#include "ldelf.h"
#include "ldelfgen.h"

/* Declare functions used by various EXTRA_EM_FILEs.  */
static void gldpruelf_before_parse (void);
static void gldpruelf_after_open (void);
static void gldpruelf_before_allocation (void);
static void gldpruelf_after_allocation (void);


#include "ldctor.h"

/* This is called after the sections have been attached to output
   sections, but before any sizes or addresses have been set.  */

static void
pruelf_before_allocation (void)
{
  /* Call the default first.  */
  gldpruelf_before_allocation ();

  /* Enable relaxation by default if the "--no-relax" option was not
     specified.  This is done here instead of in the before_parse hook
     because there is a check in main() to prohibit use of --relax and
     -r together.  */
  if (RELAXATION_DISABLED_BY_DEFAULT)
    ENABLE_RELAXATION;
}


static void
gldpruelf_before_parse (void)
{
  ldfile_set_output_arch ("pru", bfd_arch_pru);
  input_flags.dynamic = true;
  config.has_shared = false;
  config.separate_code = false;
  link_info.check_relocs_after_open_input = true;
  link_info.relro = DEFAULT_LD_Z_RELRO;
  link_info.separate_code = DEFAULT_LD_Z_SEPARATE_CODE;
}


/* These variables are used to implement target options */

static char *audit; /* colon (typically) separated list of libs */
static char *depaudit; /* colon (typically) separated list of libs */


/* This is called after all the input files have been opened.  */

static void
gldpruelf_after_open (void)
{
  ldelf_after_open (true, true,
		    true, false, 32, "/usr");
}


/* This is called after the sections have been attached to output
   sections, but before any sizes or addresses have been set.  */

static void
gldpruelf_before_allocation (void)
{
  ldelf_before_allocation (audit, depaudit, NULL);
}


static void
gldpruelf_after_allocation (void)
{
  int need_layout = bfd_elf_discard_info (link_info.output_bfd, &link_info);

  if (need_layout < 0)
    einfo (_("%X%P: .eh_frame/.stab edit: %E\n"));
  else
    ldelf_map_segments (need_layout);
}

static char *
gldpruelf_get_script (int *isfile)
{
  *isfile = 0;

  if (bfd_link_relocatable (&link_info) && config.build_constructors)
    return
"/* Script for -Ur */\n\
OUTPUT_FORMAT(\"elf32-pru\",\"elf32-pru\",\"elf32-pru\")\n\
OUTPUT_ARCH(pru)\n\
SECTIONS\n\
{\n\
  /* Read-only sections, merged into text segment: */\n\
  .hash        0 : { *(.hash)		}\n\
  .dynsym      0 : { *(.dynsym)		}\n\
  .dynstr      0 : { *(.dynstr)		}\n\
  .gnu.version 0 : { *(.gnu.version)	}\n\
  .gnu.version_d 0 : { *(.gnu.version_d)	}\n\
  .gnu.version_r 0 : { *(.gnu.version_r)	}\n\
  .rel.init    0 : { *(.rel.init)		}\n\
  .rela.init   0 : { *(.rela.init)	}\n\
  .rel.text    0 :\n\
    {\n\
      *(.rel.text)\n\
    }\n\
  .rela.text   0 :\n\
    {\n\
      *(.rela.text)\n\
    }\n\
  .rel.fini    0 : { *(.rel.fini)		}\n\
  .rela.fini   0 : { *(.rela.fini)	}\n\
  .rel.rodata  0 :\n"
"    {\n\
      *(.rel.rodata)\n\
    }\n\
  .rela.rodata 0 :\n\
    {\n\
      *(.rela.rodata)\n\
    }\n\
  .rel.data    0 :\n\
    {\n\
      *(.rel.data)\n\
    }\n\
  .rela.data   0 :\n\
    {\n\
      *(.rela.data)\n\
    }\n\
  .rel.init_array   	0 : { *(.rel.init_array)	}\n\
  .rela.init_array  	0 : { *(.rela.init_array)	}\n\
  .rel.fini_array   	0 : { *(.rel.fini_array)	}\n\
  .rela.fini_array  	0 : { *(.rela.fini_array)	}\n\
  .rel.got     		0 : { *(.rel.got)		}\n\
  .rela.got    		0 : { *(.rela.got)	}\n\
  .rel.bss     		0 : { *(.rel.bss)		}\n\
  .rela.bss    		0 : { *(.rela.bss)	}\n\
  .rel.plt     		0 : { *(.rel.plt)		}\n\
  .rela.plt    		0 : { *(.rela.plt)	}\n"
"  /* Internal text space.  */\n\
  .text 0 :\n\
  {\n\
    *(.text)\n\
  }\n\
  .data        0 :\n\
  {\n\
    /* Optional variable that user is prepared to have NULL address.  */\n\
    /* CRT is prepared for constructor/destructor table to have\n\
       a \"valid\" NULL address.  */\n\
     __init_array_start = . ;\n\
     KEEP (*(SORT_BY_INIT_PRIORITY(.init_array.*)))\n\
     KEEP (*(.init_array))\n\
     __init_array_end = . ;\n\
     __fini_array_start = . ;\n\
     KEEP (*(SORT_BY_INIT_PRIORITY(.fini_array.*)))\n\
     KEEP (*(.fini_array))\n\
     __fini_array_end = . ;\n\
    *(.data)\n\
  }\n\
  /* Linux remoteproc loader requires the resource_table section\n\
     start address to be aligned to 8 bytes.  */\n\
  .resource_table 0  :\n\
  {\n\
    KEEP (*(.resource_table))\n"
"  }\n\
  .bss 0 :\n\
  {\n\
    *(.bss)\n\
  }\n\
  /* Global data not cleared after reset.  */\n\
  .noinit 0 :\n\
  {\n\
    *(.noinit)\n\
  }\n\
  /* Remoteproc loader in Linux kernel 5.10 and later reads this section\n\
     to setup the PRUSS interrupt controller.  The interrupt map section\n\
     is never referenced from PRU firmware, so there is no need to\n\
     place it in the target dmem memory.  */\n\
  .pru_irq_map 0 : { *(.pru_irq_map) }\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  .note.gnu.build-id 0 : { *(.note.gnu.build-id) }\n\
  /* DWARF debug sections.\n"
"     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1.  */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions.  */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2.  */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2.  */\n\
  .debug_info     0 : { *(.debug_info) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
  /* SGI/MIPS DWARF 2 extensions.  */\n\
  .debug_weaknames 0 : { *(.debug_weaknames) }\n\
  .debug_funcnames 0 : { *(.debug_funcnames) }\n\
  .debug_typenames 0 : { *(.debug_typenames) }\n\
  .debug_varnames  0 : { *(.debug_varnames) }\n\
  /* DWARF 3.  */\n\
  .debug_pubtypes 0 : { *(.debug_pubtypes) }\n\
  .debug_ranges   0 : { *(.debug_ranges) }\n\
  /* DWARF 5.  */\n\
  .debug_addr     0 : { *(.debug_addr) }\n\
  .debug_line_str 0 : { *(.debug_line_str) }\n\
  .debug_loclists 0 : { *(.debug_loclists) }\n\
  .debug_macro    0 : { *(.debug_macro) }\n\
  .debug_names    0 : { *(.debug_names) }\n\
  .debug_rnglists 0 : { *(.debug_rnglists) }\n\
  .debug_str_offsets 0 : { *(.debug_str_offsets) }\n\
  .debug_sup      0 : { *(.debug_sup) }\n\
}\n\n"
  ; else if (bfd_link_relocatable (&link_info)) return
"/* Script for -r */\n\
OUTPUT_FORMAT(\"elf32-pru\",\"elf32-pru\",\"elf32-pru\")\n\
OUTPUT_ARCH(pru)\n\
SECTIONS\n\
{\n\
  /* Read-only sections, merged into text segment: */\n\
  .hash        0 : { *(.hash)		}\n\
  .dynsym      0 : { *(.dynsym)		}\n\
  .dynstr      0 : { *(.dynstr)		}\n\
  .gnu.version 0 : { *(.gnu.version)	}\n\
  .gnu.version_d 0 : { *(.gnu.version_d)	}\n\
  .gnu.version_r 0 : { *(.gnu.version_r)	}\n\
  .rel.init    0 : { *(.rel.init)		}\n\
  .rela.init   0 : { *(.rela.init)	}\n\
  .rel.text    0 :\n\
    {\n\
      *(.rel.text)\n\
    }\n\
  .rela.text   0 :\n\
    {\n\
      *(.rela.text)\n\
    }\n\
  .rel.fini    0 : { *(.rel.fini)		}\n\
  .rela.fini   0 : { *(.rela.fini)	}\n\
  .rel.rodata  0 :\n"
"    {\n\
      *(.rel.rodata)\n\
    }\n\
  .rela.rodata 0 :\n\
    {\n\
      *(.rela.rodata)\n\
    }\n\
  .rel.data    0 :\n\
    {\n\
      *(.rel.data)\n\
    }\n\
  .rela.data   0 :\n\
    {\n\
      *(.rela.data)\n\
    }\n\
  .rel.init_array   	0 : { *(.rel.init_array)	}\n\
  .rela.init_array  	0 : { *(.rela.init_array)	}\n\
  .rel.fini_array   	0 : { *(.rel.fini_array)	}\n\
  .rela.fini_array  	0 : { *(.rela.fini_array)	}\n\
  .rel.got     		0 : { *(.rel.got)		}\n\
  .rela.got    		0 : { *(.rela.got)	}\n\
  .rel.bss     		0 : { *(.rel.bss)		}\n\
  .rela.bss    		0 : { *(.rela.bss)	}\n\
  .rel.plt     		0 : { *(.rel.plt)		}\n\
  .rela.plt    		0 : { *(.rela.plt)	}\n"
"  /* Internal text space.  */\n\
  .text 0 :\n\
  {\n\
    *(.text)\n\
  }\n\
  .data        0 :\n\
  {\n\
    /* Optional variable that user is prepared to have NULL address.  */\n\
    /* CRT is prepared for constructor/destructor table to have\n\
       a \"valid\" NULL address.  */\n\
    *(.data)\n\
  }\n\
  /* Linux remoteproc loader requires the resource_table section\n\
     start address to be aligned to 8 bytes.  */\n\
  .resource_table 0  :\n\
  {\n\
    KEEP (*(.resource_table))\n\
  }\n\
  .bss 0 :\n\
  {\n\
    *(.bss)\n\
  }\n\
  /* Global data not cleared after reset.  */\n\
  .noinit 0 :\n\
  {\n"
"    *(.noinit)\n\
  }\n\
  /* Remoteproc loader in Linux kernel 5.10 and later reads this section\n\
     to setup the PRUSS interrupt controller.  The interrupt map section\n\
     is never referenced from PRU firmware, so there is no need to\n\
     place it in the target dmem memory.  */\n\
  .pru_irq_map 0 : { *(.pru_irq_map) }\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  .note.gnu.build-id 0 : { *(.note.gnu.build-id) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1.  */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions.  */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n"
"  /* DWARF 1.1 and DWARF 2.  */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2.  */\n\
  .debug_info     0 : { *(.debug_info) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
  /* SGI/MIPS DWARF 2 extensions.  */\n\
  .debug_weaknames 0 : { *(.debug_weaknames) }\n\
  .debug_funcnames 0 : { *(.debug_funcnames) }\n\
  .debug_typenames 0 : { *(.debug_typenames) }\n\
  .debug_varnames  0 : { *(.debug_varnames) }\n\
  /* DWARF 3.  */\n\
  .debug_pubtypes 0 : { *(.debug_pubtypes) }\n\
  .debug_ranges   0 : { *(.debug_ranges) }\n\
  /* DWARF 5.  */\n\
  .debug_addr     0 : { *(.debug_addr) }\n\
  .debug_line_str 0 : { *(.debug_line_str) }\n\
  .debug_loclists 0 : { *(.debug_loclists) }\n\
  .debug_macro    0 : { *(.debug_macro) }\n\
  .debug_names    0 : { *(.debug_names) }\n\
  .debug_rnglists 0 : { *(.debug_rnglists) }\n\
  .debug_str_offsets 0 : { *(.debug_str_offsets) }\n\
  .debug_sup      0 : { *(.debug_sup) }\n\
}\n\n"
  ; else if (!config.text_read_only) return
"/* Script for -N */\n\
OUTPUT_FORMAT(\"elf32-pru\",\"elf32-pru\",\"elf32-pru\")\n\
OUTPUT_ARCH(pru)\n\
/* Allow memory sizes to be overridden from command line.  */\n\
__IMEM_SIZE = DEFINED(__IMEM_SIZE) ? __IMEM_SIZE : 8K;\n\
__DMEM_SIZE = DEFINED(__DMEM_SIZE) ? __DMEM_SIZE : 8K;\n\
MEMORY\n\
{\n\
  imem   (x)   : ORIGIN = 0x20000000, LENGTH = __IMEM_SIZE\n\
  dmem   (rw!x) : ORIGIN = 0x0, LENGTH = __DMEM_SIZE\n\
}\n\
__HEAP_SIZE = DEFINED(__HEAP_SIZE) ? __HEAP_SIZE : 32;\n\
__STACK_SIZE = DEFINED(__STACK_SIZE) ? __STACK_SIZE : 512;\n\
PROVIDE (_stack_top = ORIGIN(dmem) + LENGTH(dmem));\n\
ENTRY (_start)\n\
SECTIONS\n\
{\n\
  /* Read-only sections, merged into text segment: */\n\
  .hash          : { *(.hash)		}\n\
  .dynsym        : { *(.dynsym)		}\n\
  .dynstr        : { *(.dynstr)		}\n\
  .gnu.version   : { *(.gnu.version)	}\n\
  .gnu.version_d   : { *(.gnu.version_d)	}\n\
  .gnu.version_r   : { *(.gnu.version_r)	}\n\
  .rel.init      : { *(.rel.init)		}\n"
"  .rela.init     : { *(.rela.init)	}\n\
  .rel.text      :\n\
    {\n\
      *(.rel.text)\n\
      *(.rel.text.*)\n\
      *(.rel.text:*)\n\
      *(.rel.gnu.linkonce.t*)\n\
    }\n\
  .rela.text     :\n\
    {\n\
      *(.rela.text)\n\
      *(.rela.text.*)\n\
      *(.rela.text:*)\n\
      *(.rela.gnu.linkonce.t*)\n\
    }\n\
  .rel.fini      : { *(.rel.fini)		}\n\
  .rela.fini     : { *(.rela.fini)	}\n\
  .rel.rodata    :\n\
    {\n\
      *(.rel.rodata)\n\
      *(.rel.rodata.*)\n\
      *(.rel.rodata:*)\n\
      *(.rel.gnu.linkonce.r*)\n\
    }\n\
  .rela.rodata   :\n"
"    {\n\
      *(.rela.rodata)\n\
      *(.rela.rodata.*)\n\
      *(.rela.rodata:*)\n\
      *(.rela.gnu.linkonce.r*)\n\
    }\n\
  .rel.data      :\n\
    {\n\
      *(.rel.data)\n\
      *(.rel.data.*)\n\
      *(.rel.data:*)\n\
      *(.rel.gnu.linkonce.d*)\n\
    }\n\
  .rela.data     :\n\
    {\n\
      *(.rela.data)\n\
      *(.rela.data.*)\n\
      *(.rela.data:*)\n\
      *(.rela.gnu.linkonce.d*)\n\
    }\n\
  .rel.init_array   	  : { *(.rel.init_array)	}\n\
  .rela.init_array  	  : { *(.rela.init_array)	}\n\
  .rel.fini_array   	  : { *(.rel.fini_array)	}\n\
  .rela.fini_array  	  : { *(.rela.fini_array)	}\n\
  .rel.got     		  : { *(.rel.got)		}\n"
"  .rela.got    		  : { *(.rela.got)	}\n\
  .rel.bss     		  : { *(.rel.bss)		}\n\
  .rela.bss    		  : { *(.rela.bss)	}\n\
  .rel.plt     		  : { *(.rel.plt)		}\n\
  .rela.plt    		  : { *(.rela.plt)	}\n\
  /* Internal text space.  */\n\
  .text   :\n\
  {\n\
     _text_start = . ;\n\
    . = ALIGN(4);\n\
    *(.init0)  /* Start here after reset.  */\n\
    KEEP (*(.init0))\n\
    . = ALIGN(4);\n\
    *(.text)\n\
    . = ALIGN(4);\n\
    *(.text.*)\n\
    . = ALIGN(4);\n\
    *(.text:*)\n\
    . = ALIGN(4);\n\
    *(.gnu.linkonce.t*)\n\
    . = ALIGN(4);\n\
     _text_end = . ;\n\
  }  > imem\n\
  .data          :\n\
  {\n"
"    /* Optional variable that user is prepared to have NULL address.  */\n\
     *(.data.atzero*)\n\
    /* CRT is prepared for constructor/destructor table to have\n\
       a \"valid\" NULL address.  */\n\
     __init_array_start = . ;\n\
     KEEP (*(SORT_BY_INIT_PRIORITY(.init_array.*)))\n\
     KEEP (*(.init_array))\n\
     __init_array_end = . ;\n\
     __fini_array_start = . ;\n\
     KEEP (*(SORT_BY_INIT_PRIORITY(.fini_array.*)))\n\
     KEEP (*(.fini_array))\n\
     __fini_array_end = . ;\n\
    /* DATA memory starts at address 0.  So to avoid placing a valid static\n\
       variable at the invalid NULL address, we introduce the .data.atzero\n\
       section.  If CRT can make some use of it - great.  Otherwise skip a\n\
       word.  In all cases .data/.bss sections must start at non-zero.  */\n\
    . += (. == 0 ? 4 : 0);\n\
     PROVIDE (_data_start = .) ;\n\
    *(.data)\n\
     *(.data*)\n\
     *(.data:*)\n\
     *(.rodata)  /* We need to include .rodata here if gcc is used.  */\n\
     *(.rodata.*) /* with -fdata-sections.  */\n\
     *(.rodata:*)\n\
    *(.gnu.linkonce.d*)\n\
    *(.gnu.linkonce.r*)\n\
    . = ALIGN(4);\n\
     PROVIDE (_data_end = .) ;\n\
  }  > dmem\n\
  /* Linux remoteproc loader requires the resource_table section\n\
     start address to be aligned to 8 bytes.  */\n\
  .resource_table    ALIGN(8) :\n\
  {\n\
    KEEP (*(.resource_table))\n\
  }  > dmem\n\
  .bss   :\n\
  {\n\
     PROVIDE (_bss_start = .) ;\n\
    *(.bss)\n\
     *(.bss.*)\n\
     *(.bss:*)\n\
    *(.gnu.linkonce.b*)\n\
    *(COMMON)\n\
     PROVIDE (_bss_end = .) ;\n\
  }  > dmem\n\
  /* Global data not cleared after reset.  */\n\
  .noinit   :\n\
  {\n\
     PROVIDE (_noinit_start = .) ;\n\
    *(.noinit .noinit.* .gnu.linkonce.n.*)\n\
     PROVIDE (_noinit_end = .) ;\n\
     PROVIDE (_heap_start = .) ;\n\
     . += __HEAP_SIZE ;\n\
    /* Stack is not here really.  It will be put at the end of DMEM.\n\
       But we take into account its size here, in order to allow\n\
       for MEMORY overflow checking during link time.  */\n\
     . += __STACK_SIZE ;\n\
  }  > dmem\n\
  /* Remoteproc loader in Linux kernel 5.10 and later reads this section\n\
     to setup the PRUSS interrupt controller.  The interrupt map section\n\
     is never referenced from PRU firmware, so there is no need to\n\
     place it in the target dmem memory.  */\n\
  .pru_irq_map 0 : { *(.pru_irq_map) }\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  .note.gnu.build-id   : { *(.note.gnu.build-id) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1.  */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions.  */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2.  */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2.  */\n\
  .debug_info     0 : { *(.debug_info .gnu.linkonce.wi.*) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line .debug_line.* .debug_line_end) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
  /* SGI/MIPS DWARF 2 extensions.  */\n\
  .debug_weaknames 0 : { *(.debug_weaknames) }\n\
  .debug_funcnames 0 : { *(.debug_funcnames) }\n\
  .debug_typenames 0 : { *(.debug_typenames) }\n\
  .debug_varnames  0 : { *(.debug_varnames) }\n\
  /* DWARF 3.  */\n\
  .debug_pubtypes 0 : { *(.debug_pubtypes) }\n\
  .debug_ranges   0 : { *(.debug_ranges) }\n\
  /* DWARF 5.  */\n\
  .debug_addr     0 : { *(.debug_addr) }\n\
  .debug_line_str 0 : { *(.debug_line_str) }\n\
  .debug_loclists 0 : { *(.debug_loclists) }\n\
  .debug_macro    0 : { *(.debug_macro) }\n\
  .debug_names    0 : { *(.debug_names) }\n\
  .debug_rnglists 0 : { *(.debug_rnglists) }\n\
  .debug_str_offsets 0 : { *(.debug_str_offsets) }\n\
  .debug_sup      0 : { *(.debug_sup) }\n\
}\n\n"
  ; else if (!config.magic_demand_paged) return
"/* Script for -n */\n\
OUTPUT_FORMAT(\"elf32-pru\",\"elf32-pru\",\"elf32-pru\")\n\
OUTPUT_ARCH(pru)\n\
/* Allow memory sizes to be overridden from command line.  */\n\
__IMEM_SIZE = DEFINED(__IMEM_SIZE) ? __IMEM_SIZE : 8K;\n\
__DMEM_SIZE = DEFINED(__DMEM_SIZE) ? __DMEM_SIZE : 8K;\n\
MEMORY\n\
{\n\
  imem   (x)   : ORIGIN = 0x20000000, LENGTH = __IMEM_SIZE\n\
  dmem   (rw!x) : ORIGIN = 0x0, LENGTH = __DMEM_SIZE\n\
}\n\
__HEAP_SIZE = DEFINED(__HEAP_SIZE) ? __HEAP_SIZE : 32;\n\
__STACK_SIZE = DEFINED(__STACK_SIZE) ? __STACK_SIZE : 512;\n\
PROVIDE (_stack_top = ORIGIN(dmem) + LENGTH(dmem));\n\
ENTRY (_start)\n\
SECTIONS\n\
{\n\
  /* Read-only sections, merged into text segment: */\n\
  .hash          : { *(.hash)		}\n\
  .dynsym        : { *(.dynsym)		}\n\
  .dynstr        : { *(.dynstr)		}\n\
  .gnu.version   : { *(.gnu.version)	}\n\
  .gnu.version_d   : { *(.gnu.version_d)	}\n\
  .gnu.version_r   : { *(.gnu.version_r)	}\n\
  .rel.init      : { *(.rel.init)		}\n"
"  .rela.init     : { *(.rela.init)	}\n\
  .rel.text      :\n\
    {\n\
      *(.rel.text)\n\
      *(.rel.text.*)\n\
      *(.rel.text:*)\n\
      *(.rel.gnu.linkonce.t*)\n\
    }\n\
  .rela.text     :\n\
    {\n\
      *(.rela.text)\n\
      *(.rela.text.*)\n\
      *(.rela.text:*)\n\
      *(.rela.gnu.linkonce.t*)\n\
    }\n\
  .rel.fini      : { *(.rel.fini)		}\n\
  .rela.fini     : { *(.rela.fini)	}\n\
  .rel.rodata    :\n\
    {\n\
      *(.rel.rodata)\n\
      *(.rel.rodata.*)\n\
      *(.rel.rodata:*)\n\
      *(.rel.gnu.linkonce.r*)\n\
    }\n\
  .rela.rodata   :\n"
"    {\n\
      *(.rela.rodata)\n\
      *(.rela.rodata.*)\n\
      *(.rela.rodata:*)\n\
      *(.rela.gnu.linkonce.r*)\n\
    }\n\
  .rel.data      :\n\
    {\n\
      *(.rel.data)\n\
      *(.rel.data.*)\n\
      *(.rel.data:*)\n\
      *(.rel.gnu.linkonce.d*)\n\
    }\n\
  .rela.data     :\n\
    {\n\
      *(.rela.data)\n\
      *(.rela.data.*)\n\
      *(.rela.data:*)\n\
      *(.rela.gnu.linkonce.d*)\n\
    }\n\
  .rel.init_array   	  : { *(.rel.init_array)	}\n\
  .rela.init_array  	  : { *(.rela.init_array)	}\n\
  .rel.fini_array   	  : { *(.rel.fini_array)	}\n\
  .rela.fini_array  	  : { *(.rela.fini_array)	}\n\
  .rel.got     		  : { *(.rel.got)		}\n"
"  .rela.got    		  : { *(.rela.got)	}\n\
  .rel.bss     		  : { *(.rel.bss)		}\n\
  .rela.bss    		  : { *(.rela.bss)	}\n\
  .rel.plt     		  : { *(.rel.plt)		}\n\
  .rela.plt    		  : { *(.rela.plt)	}\n\
  /* Internal text space.  */\n\
  .text   :\n\
  {\n\
     _text_start = . ;\n\
    . = ALIGN(4);\n\
    *(.init0)  /* Start here after reset.  */\n\
    KEEP (*(.init0))\n\
    . = ALIGN(4);\n\
    *(.text)\n\
    . = ALIGN(4);\n\
    *(.text.*)\n\
    . = ALIGN(4);\n\
    *(.text:*)\n\
    . = ALIGN(4);\n\
    *(.gnu.linkonce.t*)\n\
    . = ALIGN(4);\n\
     _text_end = . ;\n\
  }  > imem\n\
  .data          :\n\
  {\n"
"    /* Optional variable that user is prepared to have NULL address.  */\n\
     *(.data.atzero*)\n\
    /* CRT is prepared for constructor/destructor table to have\n\
       a \"valid\" NULL address.  */\n\
     __init_array_start = . ;\n\
     KEEP (*(SORT_BY_INIT_PRIORITY(.init_array.*)))\n\
     KEEP (*(.init_array))\n\
     __init_array_end = . ;\n\
     __fini_array_start = . ;\n\
     KEEP (*(SORT_BY_INIT_PRIORITY(.fini_array.*)))\n\
     KEEP (*(.fini_array))\n\
     __fini_array_end = . ;\n\
    /* DATA memory starts at address 0.  So to avoid placing a valid static\n\
       variable at the invalid NULL address, we introduce the .data.atzero\n\
       section.  If CRT can make some use of it - great.  Otherwise skip a\n\
       word.  In all cases .data/.bss sections must start at non-zero.  */\n\
    . += (. == 0 ? 4 : 0);\n\
     PROVIDE (_data_start = .) ;\n\
    *(.data)\n\
     *(.data*)\n\
     *(.data:*)\n\
     *(.rodata)  /* We need to include .rodata here if gcc is used.  */\n\
     *(.rodata.*) /* with -fdata-sections.  */\n\
     *(.rodata:*)\n\
    *(.gnu.linkonce.d*)\n\
    *(.gnu.linkonce.r*)\n\
    . = ALIGN(4);\n\
     PROVIDE (_data_end = .) ;\n\
  }  > dmem\n\
  /* Linux remoteproc loader requires the resource_table section\n\
     start address to be aligned to 8 bytes.  */\n\
  .resource_table    ALIGN(8) :\n\
  {\n\
    KEEP (*(.resource_table))\n\
  }  > dmem\n\
  .bss   :\n\
  {\n\
     PROVIDE (_bss_start = .) ;\n\
    *(.bss)\n\
     *(.bss.*)\n\
     *(.bss:*)\n\
    *(.gnu.linkonce.b*)\n\
    *(COMMON)\n\
     PROVIDE (_bss_end = .) ;\n\
  }  > dmem\n\
  /* Global data not cleared after reset.  */\n\
  .noinit   :\n\
  {\n\
     PROVIDE (_noinit_start = .) ;\n\
    *(.noinit .noinit.* .gnu.linkonce.n.*)\n\
     PROVIDE (_noinit_end = .) ;\n\
     PROVIDE (_heap_start = .) ;\n\
     . += __HEAP_SIZE ;\n\
    /* Stack is not here really.  It will be put at the end of DMEM.\n\
       But we take into account its size here, in order to allow\n\
       for MEMORY overflow checking during link time.  */\n\
     . += __STACK_SIZE ;\n\
  }  > dmem\n\
  /* Remoteproc loader in Linux kernel 5.10 and later reads this section\n\
     to setup the PRUSS interrupt controller.  The interrupt map section\n\
     is never referenced from PRU firmware, so there is no need to\n\
     place it in the target dmem memory.  */\n\
  .pru_irq_map 0 : { *(.pru_irq_map) }\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  .note.gnu.build-id   : { *(.note.gnu.build-id) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1.  */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions.  */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2.  */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2.  */\n\
  .debug_info     0 : { *(.debug_info .gnu.linkonce.wi.*) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line .debug_line.* .debug_line_end) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
  /* SGI/MIPS DWARF 2 extensions.  */\n\
  .debug_weaknames 0 : { *(.debug_weaknames) }\n\
  .debug_funcnames 0 : { *(.debug_funcnames) }\n\
  .debug_typenames 0 : { *(.debug_typenames) }\n\
  .debug_varnames  0 : { *(.debug_varnames) }\n\
  /* DWARF 3.  */\n\
  .debug_pubtypes 0 : { *(.debug_pubtypes) }\n\
  .debug_ranges   0 : { *(.debug_ranges) }\n\
  /* DWARF 5.  */\n\
  .debug_addr     0 : { *(.debug_addr) }\n\
  .debug_line_str 0 : { *(.debug_line_str) }\n\
  .debug_loclists 0 : { *(.debug_loclists) }\n\
  .debug_macro    0 : { *(.debug_macro) }\n\
  .debug_names    0 : { *(.debug_names) }\n\
  .debug_rnglists 0 : { *(.debug_rnglists) }\n\
  .debug_str_offsets 0 : { *(.debug_str_offsets) }\n\
  .debug_sup      0 : { *(.debug_sup) }\n\
}\n\n"
  ; else if (link_info.separate_code) return
"/* Script for -z separate-code */\n\
OUTPUT_FORMAT(\"elf32-pru\",\"elf32-pru\",\"elf32-pru\")\n\
OUTPUT_ARCH(pru)\n\
/* Allow memory sizes to be overridden from command line.  */\n\
__IMEM_SIZE = DEFINED(__IMEM_SIZE) ? __IMEM_SIZE : 8K;\n\
__DMEM_SIZE = DEFINED(__DMEM_SIZE) ? __DMEM_SIZE : 8K;\n\
MEMORY\n\
{\n\
  imem   (x)   : ORIGIN = 0x20000000, LENGTH = __IMEM_SIZE\n\
  dmem   (rw!x) : ORIGIN = 0x0, LENGTH = __DMEM_SIZE\n\
}\n\
__HEAP_SIZE = DEFINED(__HEAP_SIZE) ? __HEAP_SIZE : 32;\n\
__STACK_SIZE = DEFINED(__STACK_SIZE) ? __STACK_SIZE : 512;\n\
PROVIDE (_stack_top = ORIGIN(dmem) + LENGTH(dmem));\n\
ENTRY (_start)\n\
SECTIONS\n\
{\n\
  /* Read-only sections, merged into text segment: */\n\
  .hash          : { *(.hash)		}\n\
  .dynsym        : { *(.dynsym)		}\n\
  .dynstr        : { *(.dynstr)		}\n\
  .gnu.version   : { *(.gnu.version)	}\n\
  .gnu.version_d   : { *(.gnu.version_d)	}\n\
  .gnu.version_r   : { *(.gnu.version_r)	}\n\
  .rel.init      : { *(.rel.init)		}\n"
"  .rela.init     : { *(.rela.init)	}\n\
  .rel.text      :\n\
    {\n\
      *(.rel.text)\n\
      *(.rel.text.*)\n\
      *(.rel.text:*)\n\
      *(.rel.gnu.linkonce.t*)\n\
    }\n\
  .rela.text     :\n\
    {\n\
      *(.rela.text)\n\
      *(.rela.text.*)\n\
      *(.rela.text:*)\n\
      *(.rela.gnu.linkonce.t*)\n\
    }\n\
  .rel.fini      : { *(.rel.fini)		}\n\
  .rela.fini     : { *(.rela.fini)	}\n\
  .rel.rodata    :\n\
    {\n\
      *(.rel.rodata)\n\
      *(.rel.rodata.*)\n\
      *(.rel.rodata:*)\n\
      *(.rel.gnu.linkonce.r*)\n\
    }\n\
  .rela.rodata   :\n"
"    {\n\
      *(.rela.rodata)\n\
      *(.rela.rodata.*)\n\
      *(.rela.rodata:*)\n\
      *(.rela.gnu.linkonce.r*)\n\
    }\n\
  .rel.data      :\n\
    {\n\
      *(.rel.data)\n\
      *(.rel.data.*)\n\
      *(.rel.data:*)\n\
      *(.rel.gnu.linkonce.d*)\n\
    }\n\
  .rela.data     :\n\
    {\n\
      *(.rela.data)\n\
      *(.rela.data.*)\n\
      *(.rela.data:*)\n\
      *(.rela.gnu.linkonce.d*)\n\
    }\n\
  .rel.init_array   	  : { *(.rel.init_array)	}\n\
  .rela.init_array  	  : { *(.rela.init_array)	}\n\
  .rel.fini_array   	  : { *(.rel.fini_array)	}\n\
  .rela.fini_array  	  : { *(.rela.fini_array)	}\n\
  .rel.got     		  : { *(.rel.got)		}\n"
"  .rela.got    		  : { *(.rela.got)	}\n\
  .rel.bss     		  : { *(.rel.bss)		}\n\
  .rela.bss    		  : { *(.rela.bss)	}\n\
  .rel.plt     		  : { *(.rel.plt)		}\n\
  .rela.plt    		  : { *(.rela.plt)	}\n\
  /* Internal text space.  */\n\
  .text   :\n\
  {\n\
     _text_start = . ;\n\
    . = ALIGN(4);\n\
    *(.init0)  /* Start here after reset.  */\n\
    KEEP (*(.init0))\n\
    . = ALIGN(4);\n\
    *(.text)\n\
    . = ALIGN(4);\n\
    *(.text.*)\n\
    . = ALIGN(4);\n\
    *(.text:*)\n\
    . = ALIGN(4);\n\
    *(.gnu.linkonce.t*)\n\
    . = ALIGN(4);\n\
     _text_end = . ;\n\
  }  > imem\n\
  .data          :\n\
  {\n"
"    /* Optional variable that user is prepared to have NULL address.  */\n\
     *(.data.atzero*)\n\
    /* CRT is prepared for constructor/destructor table to have\n\
       a \"valid\" NULL address.  */\n\
     __init_array_start = . ;\n\
     KEEP (*(SORT_BY_INIT_PRIORITY(.init_array.*)))\n\
     KEEP (*(.init_array))\n\
     __init_array_end = . ;\n\
     __fini_array_start = . ;\n\
     KEEP (*(SORT_BY_INIT_PRIORITY(.fini_array.*)))\n\
     KEEP (*(.fini_array))\n\
     __fini_array_end = . ;\n\
    /* DATA memory starts at address 0.  So to avoid placing a valid static\n\
       variable at the invalid NULL address, we introduce the .data.atzero\n\
       section.  If CRT can make some use of it - great.  Otherwise skip a\n\
       word.  In all cases .data/.bss sections must start at non-zero.  */\n\
    . += (. == 0 ? 4 : 0);\n\
     PROVIDE (_data_start = .) ;\n\
    *(.data)\n\
     *(.data*)\n\
     *(.data:*)\n\
     *(.rodata)  /* We need to include .rodata here if gcc is used.  */\n\
     *(.rodata.*) /* with -fdata-sections.  */\n\
     *(.rodata:*)\n\
    *(.gnu.linkonce.d*)\n\
    *(.gnu.linkonce.r*)\n\
    . = ALIGN(4);\n\
     PROVIDE (_data_end = .) ;\n\
  }  > dmem\n\
  /* Linux remoteproc loader requires the resource_table section\n\
     start address to be aligned to 8 bytes.  */\n\
  .resource_table    ALIGN(8) :\n\
  {\n\
    KEEP (*(.resource_table))\n\
  }  > dmem\n\
  .bss   :\n\
  {\n\
     PROVIDE (_bss_start = .) ;\n\
    *(.bss)\n\
     *(.bss.*)\n\
     *(.bss:*)\n\
    *(.gnu.linkonce.b*)\n\
    *(COMMON)\n\
     PROVIDE (_bss_end = .) ;\n\
  }  > dmem\n\
  /* Global data not cleared after reset.  */\n\
  .noinit   :\n\
  {\n\
     PROVIDE (_noinit_start = .) ;\n\
    *(.noinit .noinit.* .gnu.linkonce.n.*)\n\
     PROVIDE (_noinit_end = .) ;\n\
     PROVIDE (_heap_start = .) ;\n\
     . += __HEAP_SIZE ;\n\
    /* Stack is not here really.  It will be put at the end of DMEM.\n\
       But we take into account its size here, in order to allow\n\
       for MEMORY overflow checking during link time.  */\n\
     . += __STACK_SIZE ;\n\
  }  > dmem\n\
  /* Remoteproc loader in Linux kernel 5.10 and later reads this section\n\
     to setup the PRUSS interrupt controller.  The interrupt map section\n\
     is never referenced from PRU firmware, so there is no need to\n\
     place it in the target dmem memory.  */\n\
  .pru_irq_map 0 : { *(.pru_irq_map) }\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  .note.gnu.build-id   : { *(.note.gnu.build-id) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1.  */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions.  */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2.  */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2.  */\n\
  .debug_info     0 : { *(.debug_info .gnu.linkonce.wi.*) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line .debug_line.* .debug_line_end) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
  /* SGI/MIPS DWARF 2 extensions.  */\n\
  .debug_weaknames 0 : { *(.debug_weaknames) }\n\
  .debug_funcnames 0 : { *(.debug_funcnames) }\n\
  .debug_typenames 0 : { *(.debug_typenames) }\n\
  .debug_varnames  0 : { *(.debug_varnames) }\n\
  /* DWARF 3.  */\n\
  .debug_pubtypes 0 : { *(.debug_pubtypes) }\n\
  .debug_ranges   0 : { *(.debug_ranges) }\n\
  /* DWARF 5.  */\n\
  .debug_addr     0 : { *(.debug_addr) }\n\
  .debug_line_str 0 : { *(.debug_line_str) }\n\
  .debug_loclists 0 : { *(.debug_loclists) }\n\
  .debug_macro    0 : { *(.debug_macro) }\n\
  .debug_names    0 : { *(.debug_names) }\n\
  .debug_rnglists 0 : { *(.debug_rnglists) }\n\
  .debug_str_offsets 0 : { *(.debug_str_offsets) }\n\
  .debug_sup      0 : { *(.debug_sup) }\n\
}\n\n"
  ; else return
"/* Default linker script, for normal executables */\n\
OUTPUT_FORMAT(\"elf32-pru\",\"elf32-pru\",\"elf32-pru\")\n\
OUTPUT_ARCH(pru)\n\
/* Allow memory sizes to be overridden from command line.  */\n\
__IMEM_SIZE = DEFINED(__IMEM_SIZE) ? __IMEM_SIZE : 8K;\n\
__DMEM_SIZE = DEFINED(__DMEM_SIZE) ? __DMEM_SIZE : 8K;\n\
MEMORY\n\
{\n\
  imem   (x)   : ORIGIN = 0x20000000, LENGTH = __IMEM_SIZE\n\
  dmem   (rw!x) : ORIGIN = 0x0, LENGTH = __DMEM_SIZE\n\
}\n\
__HEAP_SIZE = DEFINED(__HEAP_SIZE) ? __HEAP_SIZE : 32;\n\
__STACK_SIZE = DEFINED(__STACK_SIZE) ? __STACK_SIZE : 512;\n\
PROVIDE (_stack_top = ORIGIN(dmem) + LENGTH(dmem));\n\
ENTRY (_start)\n\
SECTIONS\n\
{\n\
  /* Read-only sections, merged into text segment: */\n\
  .hash          : { *(.hash)		}\n\
  .dynsym        : { *(.dynsym)		}\n\
  .dynstr        : { *(.dynstr)		}\n\
  .gnu.version   : { *(.gnu.version)	}\n\
  .gnu.version_d   : { *(.gnu.version_d)	}\n\
  .gnu.version_r   : { *(.gnu.version_r)	}\n\
  .rel.init      : { *(.rel.init)		}\n"
"  .rela.init     : { *(.rela.init)	}\n\
  .rel.text      :\n\
    {\n\
      *(.rel.text)\n\
      *(.rel.text.*)\n\
      *(.rel.text:*)\n\
      *(.rel.gnu.linkonce.t*)\n\
    }\n\
  .rela.text     :\n\
    {\n\
      *(.rela.text)\n\
      *(.rela.text.*)\n\
      *(.rela.text:*)\n\
      *(.rela.gnu.linkonce.t*)\n\
    }\n\
  .rel.fini      : { *(.rel.fini)		}\n\
  .rela.fini     : { *(.rela.fini)	}\n\
  .rel.rodata    :\n\
    {\n\
      *(.rel.rodata)\n\
      *(.rel.rodata.*)\n\
      *(.rel.rodata:*)\n\
      *(.rel.gnu.linkonce.r*)\n\
    }\n\
  .rela.rodata   :\n"
"    {\n\
      *(.rela.rodata)\n\
      *(.rela.rodata.*)\n\
      *(.rela.rodata:*)\n\
      *(.rela.gnu.linkonce.r*)\n\
    }\n\
  .rel.data      :\n\
    {\n\
      *(.rel.data)\n\
      *(.rel.data.*)\n\
      *(.rel.data:*)\n\
      *(.rel.gnu.linkonce.d*)\n\
    }\n\
  .rela.data     :\n\
    {\n\
      *(.rela.data)\n\
      *(.rela.data.*)\n\
      *(.rela.data:*)\n\
      *(.rela.gnu.linkonce.d*)\n\
    }\n\
  .rel.init_array   	  : { *(.rel.init_array)	}\n\
  .rela.init_array  	  : { *(.rela.init_array)	}\n\
  .rel.fini_array   	  : { *(.rel.fini_array)	}\n\
  .rela.fini_array  	  : { *(.rela.fini_array)	}\n\
  .rel.got     		  : { *(.rel.got)		}\n"
"  .rela.got    		  : { *(.rela.got)	}\n\
  .rel.bss     		  : { *(.rel.bss)		}\n\
  .rela.bss    		  : { *(.rela.bss)	}\n\
  .rel.plt     		  : { *(.rel.plt)		}\n\
  .rela.plt    		  : { *(.rela.plt)	}\n\
  /* Internal text space.  */\n\
  .text   :\n\
  {\n\
     _text_start = . ;\n\
    . = ALIGN(4);\n\
    *(.init0)  /* Start here after reset.  */\n\
    KEEP (*(.init0))\n\
    . = ALIGN(4);\n\
    *(.text)\n\
    . = ALIGN(4);\n\
    *(.text.*)\n\
    . = ALIGN(4);\n\
    *(.text:*)\n\
    . = ALIGN(4);\n\
    *(.gnu.linkonce.t*)\n\
    . = ALIGN(4);\n\
     _text_end = . ;\n\
  }  > imem\n\
  .data          :\n\
  {\n"
"    /* Optional variable that user is prepared to have NULL address.  */\n\
     *(.data.atzero*)\n\
    /* CRT is prepared for constructor/destructor table to have\n\
       a \"valid\" NULL address.  */\n\
     __init_array_start = . ;\n\
     KEEP (*(SORT_BY_INIT_PRIORITY(.init_array.*)))\n\
     KEEP (*(.init_array))\n\
     __init_array_end = . ;\n\
     __fini_array_start = . ;\n\
     KEEP (*(SORT_BY_INIT_PRIORITY(.fini_array.*)))\n\
     KEEP (*(.fini_array))\n\
     __fini_array_end = . ;\n\
    /* DATA memory starts at address 0.  So to avoid placing a valid static\n\
       variable at the invalid NULL address, we introduce the .data.atzero\n\
       section.  If CRT can make some use of it - great.  Otherwise skip a\n\
       word.  In all cases .data/.bss sections must start at non-zero.  */\n\
    . += (. == 0 ? 4 : 0);\n\
     PROVIDE (_data_start = .) ;\n\
    *(.data)\n\
     *(.data*)\n\
     *(.data:*)\n\
     *(.rodata)  /* We need to include .rodata here if gcc is used.  */\n\
     *(.rodata.*) /* with -fdata-sections.  */\n\
     *(.rodata:*)\n\
    *(.gnu.linkonce.d*)\n\
    *(.gnu.linkonce.r*)\n\
    . = ALIGN(4);\n\
     PROVIDE (_data_end = .) ;\n\
  }  > dmem\n\
  /* Linux remoteproc loader requires the resource_table section\n\
     start address to be aligned to 8 bytes.  */\n\
  .resource_table    ALIGN(8) :\n\
  {\n\
    KEEP (*(.resource_table))\n\
  }  > dmem\n\
  .bss   :\n\
  {\n\
     PROVIDE (_bss_start = .) ;\n\
    *(.bss)\n\
     *(.bss.*)\n\
     *(.bss:*)\n\
    *(.gnu.linkonce.b*)\n\
    *(COMMON)\n\
     PROVIDE (_bss_end = .) ;\n\
  }  > dmem\n\
  /* Global data not cleared after reset.  */\n\
  .noinit   :\n\
  {\n\
     PROVIDE (_noinit_start = .) ;\n\
    *(.noinit .noinit.* .gnu.linkonce.n.*)\n\
     PROVIDE (_noinit_end = .) ;\n\
     PROVIDE (_heap_start = .) ;\n\
     . += __HEAP_SIZE ;\n\
    /* Stack is not here really.  It will be put at the end of DMEM.\n\
       But we take into account its size here, in order to allow\n\
       for MEMORY overflow checking during link time.  */\n\
     . += __STACK_SIZE ;\n\
  }  > dmem\n\
  /* Remoteproc loader in Linux kernel 5.10 and later reads this section\n\
     to setup the PRUSS interrupt controller.  The interrupt map section\n\
     is never referenced from PRU firmware, so there is no need to\n\
     place it in the target dmem memory.  */\n\
  .pru_irq_map 0 : { *(.pru_irq_map) }\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  .note.gnu.build-id   : { *(.note.gnu.build-id) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1.  */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions.  */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2.  */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2.  */\n\
  .debug_info     0 : { *(.debug_info .gnu.linkonce.wi.*) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line .debug_line.* .debug_line_end) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
  /* SGI/MIPS DWARF 2 extensions.  */\n\
  .debug_weaknames 0 : { *(.debug_weaknames) }\n\
  .debug_funcnames 0 : { *(.debug_funcnames) }\n\
  .debug_typenames 0 : { *(.debug_typenames) }\n\
  .debug_varnames  0 : { *(.debug_varnames) }\n\
  /* DWARF 3.  */\n\
  .debug_pubtypes 0 : { *(.debug_pubtypes) }\n\
  .debug_ranges   0 : { *(.debug_ranges) }\n\
  /* DWARF 5.  */\n\
  .debug_addr     0 : { *(.debug_addr) }\n\
  .debug_line_str 0 : { *(.debug_line_str) }\n\
  .debug_loclists 0 : { *(.debug_loclists) }\n\
  .debug_macro    0 : { *(.debug_macro) }\n\
  .debug_names    0 : { *(.debug_names) }\n\
  .debug_rnglists 0 : { *(.debug_rnglists) }\n\
  .debug_str_offsets 0 : { *(.debug_str_offsets) }\n\
  .debug_sup      0 : { *(.debug_sup) }\n\
}\n\n"
; }

enum elf_options
{
  OPTION_DISABLE_NEW_DTAGS = 400,
  OPTION_ENABLE_NEW_DTAGS,
  OPTION_GROUP,
  OPTION_EH_FRAME_HDR,
  OPTION_NO_EH_FRAME_HDR,
  OPTION_EXCLUDE_LIBS,
  OPTION_HASH_STYLE,
  OPTION_BUILD_ID,
  OPTION_AUDIT,
  OPTION_COMPRESS_DEBUG
};

static void
gldpruelf_add_options
  (int ns, char **shortopts, int nl, struct option **longopts,
   int nrl ATTRIBUTE_UNUSED, struct option **really_longopts ATTRIBUTE_UNUSED)
{
  static const char xtra_short[] = "z:";
  static const struct option xtra_long[] = {
    {"build-id", optional_argument, NULL, OPTION_BUILD_ID},
    {"compress-debug-sections", required_argument, NULL, OPTION_COMPRESS_DEBUG},
    {NULL, no_argument, NULL, 0}
  };

  *shortopts = (char *) xrealloc (*shortopts, ns + sizeof (xtra_short));
  memcpy (*shortopts + ns, &xtra_short, sizeof (xtra_short));
  *longopts = (struct option *)
    xrealloc (*longopts, nl * sizeof (struct option) + sizeof (xtra_long));
  memcpy (*longopts + nl, &xtra_long, sizeof (xtra_long));
}

#define DEFAULT_BUILD_ID_STYLE	"sha1"

static bool
gldpruelf_handle_option (int optc)
{
  switch (optc)
    {
    default:
      return false;

    case OPTION_BUILD_ID:
      free ((char *) ldelf_emit_note_gnu_build_id);
      ldelf_emit_note_gnu_build_id = NULL;
      if (optarg == NULL)
	optarg = DEFAULT_BUILD_ID_STYLE;
      if (strcmp (optarg, "none"))
	ldelf_emit_note_gnu_build_id = xstrdup (optarg);
      break;

    case OPTION_COMPRESS_DEBUG:
      if (strcasecmp (optarg, "none") == 0)
	link_info.compress_debug = COMPRESS_DEBUG_NONE;
      else if (strcasecmp (optarg, "zlib") == 0)
	link_info.compress_debug = COMPRESS_DEBUG_GABI_ZLIB;
      else if (strcasecmp (optarg, "zlib-gnu") == 0)
	link_info.compress_debug = COMPRESS_DEBUG_GNU_ZLIB;
      else if (strcasecmp (optarg, "zlib-gabi") == 0)
	link_info.compress_debug = COMPRESS_DEBUG_GABI_ZLIB;
      else
	einfo (_("%F%P: invalid --compress-debug-sections option: `%s'\n"),
	       optarg);
      break;
    case 'z':
      if (strcmp (optarg, "defs") == 0)
	link_info.unresolved_syms_in_objects = RM_DIAGNOSE;
      else if (strcmp (optarg, "undefs") == 0)
	link_info.unresolved_syms_in_objects = RM_IGNORE;
      else if (strcmp (optarg, "muldefs") == 0)
	link_info.allow_multiple_definition = true;
      else if (startswith (optarg, "max-page-size="))
	{
	  char *end;

	  link_info.maxpagesize = strtoul (optarg + 14, &end, 0);
	  if (*end
	      || (link_info.maxpagesize & (link_info.maxpagesize - 1)) != 0)
	    einfo (_("%F%P: invalid maximum page size `%s'\n"),
		   optarg + 14);
	  link_info.maxpagesize_is_set = true;
	}
      else if (startswith (optarg, "common-page-size="))
	{
	  char *end;
	  link_info.commonpagesize = strtoul (optarg + 17, &end, 0);
	  if (*end
	      || (link_info.commonpagesize & (link_info.commonpagesize - 1)) != 0)
	    einfo (_("%F%P: invalid common page size `%s'\n"),
		   optarg + 17);
	  link_info.commonpagesize_is_set = true;
	}
      else if (startswith (optarg, "stack-size="))
	{
	  char *end;
	  link_info.stacksize = strtoul (optarg + 11, &end, 0);
	  if (*end || link_info.stacksize < 0)
	    einfo (_("%F%P: invalid stack size `%s'\n"), optarg + 11);
	  if (!link_info.stacksize)
	    /* Use -1 for explicit no-stack, because zero means
	       'default'.   */
	    link_info.stacksize = -1;
	}
      else if (strcmp (optarg, "execstack") == 0)
	{
	  link_info.execstack = true;
	  link_info.noexecstack = false;
	}
      else if (strcmp (optarg, "noexecstack") == 0)
	{
	  link_info.noexecstack = true;
	  link_info.execstack = false;
	}
      else if (strcmp (optarg, "unique-symbol") == 0)
	link_info.unique_symbol = true;
      else if (strcmp (optarg, "nounique-symbol") == 0)
	link_info.unique_symbol = false;
      else if (strcmp (optarg, "globalaudit") == 0)
	{
	  link_info.flags_1 |= DF_1_GLOBAUDIT;
	}
      else if (startswith (optarg, "start-stop-gc"))
	link_info.start_stop_gc = true;
      else if (startswith (optarg, "nostart-stop-gc"))
	link_info.start_stop_gc = false;
      else if (startswith (optarg, "start-stop-visibility="))
	{
	  if (strcmp (optarg, "start-stop-visibility=default") == 0)
	    link_info.start_stop_visibility = STV_DEFAULT;
	  else if (strcmp (optarg, "start-stop-visibility=internal") == 0)
	    link_info.start_stop_visibility = STV_INTERNAL;
	  else if (strcmp (optarg, "start-stop-visibility=hidden") == 0)
	    link_info.start_stop_visibility = STV_HIDDEN;
	  else if (strcmp (optarg, "start-stop-visibility=protected") == 0)
	    link_info.start_stop_visibility = STV_PROTECTED;
	  else
	    einfo (_("%F%P: invalid visibility in `-z %s'; "
		     "must be default, internal, hidden, or protected"),
		   optarg);
	}
      else
	einfo (_("%P: warning: -z %s ignored\n"), optarg);
      break;
    }

  return true;
}


struct ld_emulation_xfer_struct ld_pruelf_emulation =
{
  gldpruelf_before_parse,
  syslib_default,
  hll_default,
  ldelf_after_parse,
  gldpruelf_after_open,
  after_check_relocs_default,
  ldelf_before_place_orphans,
  gldpruelf_after_allocation,
  ldelf_set_output_arch,
  ldemul_default_target,
  pruelf_before_allocation,
  gldpruelf_get_script,
  "pruelf",
  "elf32-pru",
  finish_default,
  NULL,
  ldelf_open_dynamic_archive,
  ldelf_place_orphan,
  NULL,
  NULL,
  gldpruelf_add_options,
  gldpruelf_handle_option,
  NULL,
  NULL,
  ldelf_load_symbols,
  NULL,
  NULL,
  NULL,
  ldelf_emit_ctf_early,
  ldelf_acquire_strings_for_ctf,
  ldelf_new_dynsym_for_ctf,
  NULL
};
